module Common where

import qualified Data.Set as S

type Rvar = String
type Nam = String
type Res = String
type NRes= String
type Act = String

-- | Poor man's fixed point.
fix :: Eq a => (a -> a) -> a -> a
fix f x = let y = f x in if y == x then x else fix f y

-- | Efficient 'nub'
nubOrd :: Ord a => [a] -> [a]
nubOrd = S.toList . S.fromList

-- | Monadic version of 'and'
andM :: Monad m => [m Bool] -> m Bool
andM [] = return True
andM (x:xs) = do res <- x
                 if res then andM xs else return False
